import { Injectable } from "@angular/core";
import { LoadingController } from 'ionic-angular';
import { Observable } from "rxjs";
import { HttpService } from "@justbe_system/jb-http";
var LoadingService = (function () {
    function LoadingService(loadingCtrl, httpService) {
        this.loadingCtrl = loadingCtrl;
        this.httpService = httpService;
        this.subscriptions = new Array();
    }
    LoadingService.prototype.init = function () {
        var _this = this;
        var subOne = this.httpService.restStarted$.subscribe(function (httpRestResponse) {
            if (_this.ifLoading(httpRestResponse)) {
                _this.loading(httpRestResponse.params.loading.message, httpRestResponse.params.loading.duration).subscribe();
            }
        });
        var subTwo = this.httpService.restFinished$.subscribe(function (httpRestResponse) {
            if (_this.ifLoading(httpRestResponse)) {
                if (_this.currentLoading) {
                    _this.currentLoading.dismiss();
                    delete _this.currentLoading;
                }
            }
        });
        this.subscriptions.push(subOne, subTwo);
    };
    LoadingService.prototype.dInit = function () {
        this.subscriptions.forEach(function (sb) {
            sb.unsubscribe();
        });
        delete this.currentLoading;
    };
    LoadingService.prototype.getLoading = function (message, duration) {
        var ip = new Object();
        message ? ip.content = message : '';
        duration ? ip.duration = duration : ip.duration = 10000;
        this.currentLoading = this.loadingCtrl.create(ip);
        return this.currentLoading;
    };
    // THIS METHOD ALSO HELPS FOR MANNUAL LOADIN
    // THIS METHOD ALSO HELPS FOR MANNUAL LOADIN
    LoadingService.prototype.loading = 
    // THIS METHOD ALSO HELPS FOR MANNUAL LOADIN
    function (message, duration) {
        var _this = this;
        return new Observable(function (observer) {
            _this.getLoading(message, duration).present().then(function (res) {
                observer.next(200);
                observer.complete();
            });
        });
    };
    LoadingService.prototype.ifLoading = function (httpRestResponse) {
        if (httpRestResponse &&
            httpRestResponse.params &&
            httpRestResponse.params.loading &&
            httpRestResponse.params.loading.isLoading) {
            return true;
        }
    };
    // mannual loading
    // mannual loading
    LoadingService.prototype.load = 
    // mannual loading
    function (configurations) {
        var loading = this.loadingCtrl.create(configurations);
        loading.present();
        return loading;
    };
    LoadingService.decorators = [
        { type: Injectable },
    ];
    /** @nocollapse */
    LoadingService.ctorParameters = function () { return [
        { type: LoadingController, },
        { type: HttpService, },
    ]; };
    return LoadingService;
}());
export { LoadingService };
//# sourceMappingURL=loading.service.js.map